Index: trunk/MagicSoft/Mars/mbase/BaseLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/BaseLinkDef.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/BaseLinkDef.h	(revision 1014)
@@ -16,29 +16,29 @@
 #pragma link C++ global gLog;
 
-#pragma link C++ class MLog;
+#pragma link C++ class MLog+;
 
-#pragma link C++ class MTask;
-#pragma link C++ class MTaskList;
+#pragma link C++ class MTask+;
+#pragma link C++ class MTaskList+;
 
-#pragma link C++ class MParContainer;
-#pragma link C++ class MParList;
+#pragma link C++ class MParContainer+;
+#pragma link C++ class MParList+;
 
-#pragma link C++ class MFilter;
-#pragma link C++ class MFilterList;
+#pragma link C++ class MFilter+;
+#pragma link C++ class MFilterList+;
 
-#pragma link C++ class MEvtLoop;
+#pragma link C++ class MEvtLoop+;
 
-#pragma link C++ class MInputStreamID;
+#pragma link C++ class MInputStreamID+;
 
-#pragma link C++ class MClone;
-#pragma link C++ class MPrint;
+#pragma link C++ class MClone+;
+#pragma link C++ class MPrint+;
 
-#pragma link C++ class MReadTree;
+#pragma link C++ class MReadTree+;
 
-#pragma link C++ class MRootFileBranch;
+#pragma link C++ class MRootFileBranch+;
 
-#pragma link C++ class MWriteFile;
-#pragma link C++ class MWriteAsciiFile;
-#pragma link C++ class MWriteRootFile;
+#pragma link C++ class MWriteFile+;
+#pragma link C++ class MWriteAsciiFile+;
+#pragma link C++ class MWriteRootFile+;
 
 #pragma link C++ class MArray;
Index: trunk/MagicSoft/Mars/mbase/MAGIC.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MAGIC.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MAGIC.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MAGIC_H
-#define MAGIC_H
+#ifndef MARS_MAGIC
+#define MARS_MAGIC
 ///////////////////////////////////////////////////////////////////////////////
 //
Index: trunk/MagicSoft/Mars/mbase/MArray.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MArray.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MArray.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MARRAY_H
-#define MARRAY_H
+#ifndef MARS_MArray
+#define MARS_MArray
 
 /////////////////////////////////////////////////////////////////////////////
@@ -10,5 +10,5 @@
 /////////////////////////////////////////////////////////////////////////////
 
-#ifndef MAGIC_H
+#ifndef MARS_MAGIC
 #include "MAGIC.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MArrayB.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MArrayB.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MArrayB.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MARRAYB_H
-#define MARRAYB_H
+#ifndef MARS_MArrayB
+#define MARS_MArrayB
 
 /////////////////////////////////////////////////////////////////////////////
@@ -10,5 +10,5 @@
 /////////////////////////////////////////////////////////////////////////////
 
-#ifndef MARRAY_H
+#ifndef MARS_MArray
 #include "MArray.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MArrayS.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MArrayS.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MArrayS.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MARRAYS_H
-#define MARRAYS_H
+#ifndef MARS_MArrayS
+#define MARS_MArrayS
 
 /////////////////////////////////////////////////////////////////////////////
@@ -10,5 +10,5 @@
 /////////////////////////////////////////////////////////////////////////////
 
-#ifndef MARRAY_H
+#ifndef MARS_MArray
 #include "MArray.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MClone.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MClone.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MClone.h	(revision 1014)
@@ -1,10 +1,10 @@
-#ifndef MCLONE_H
-#define MCLONE_H
+#ifndef MARS_MClone
+#define MARS_MClone
 
-#ifndef MAGIC_H
+#ifndef MARS_MAGIC
 #include "MAGIC.h"
 #endif
 
-#ifndef MTASK_H
+#ifndef MARS_MTask
 #include "MTask.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MEvtLoop.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MEvtLoop.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MEvtLoop.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MEVTLOOP_H
-#define MEVTLOOP_H
+#ifndef MARS_MEvtLoop
+#define MARS_MEvtLoop
 
 /////////////////////////////////////////////////////////////////////////////
@@ -10,9 +10,5 @@
 /////////////////////////////////////////////////////////////////////////////
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MFilter.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MFilter.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MFilter.h	(revision 1014)
@@ -1,6 +1,6 @@
-#ifndef MFILTER_H
-#define MFILTER_H
+#ifndef MARS_MFilter
+#define MARS_MFilter
 
-#ifndef MTASK_H
+#ifndef MARS_MTask
 #include "MTask.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MFilterList.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MFilterList.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MFilterList.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MFILTERLIST_H
-#define MFILTERLIST_H
+#ifndef MARS_MFilterList
+#define MARS_MFilterList
 
 /////////////////////////////////////////////////////////////////////////////
@@ -13,5 +13,5 @@
 #include <TOrdCollection.h>
 #endif
-#ifndef MFILTER_H
+#ifndef MARS_MFilter
 #include "MFilter.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MHtml.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MHtml.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MHtml.h	(revision 1014)
@@ -1,3 +1,3 @@
-// @(#)root/html:$Name: not supported by cvs2svn $:$Id: MHtml.h,v 1.1 2001-04-18 13:34:30 tbretz Exp $
+// @(#)root/html:$Name: not supported by cvs2svn $:$Id: MHtml.h,v 1.2 2001-10-30 13:26:36 tbretz Exp $
 // Author: Nenad Buncic   18/10/95
 
@@ -10,6 +10,6 @@
  *************************************************************************/
 
-#ifndef ROOT_MHtml
-#define ROOT_MHtml
+#ifndef MARS_MHtml
+#define MARS_MHtml
 
 
@@ -23,7 +23,7 @@
 ////////////////////////////////////////////////////////////////////////////
 
-#ifndef ROOT_TNamed
-#include "TNamed.h"
-#endif
+//#ifndef ROOT_TNamed
+//#include "TNamed.h"
+//#endif
 
 
Index: trunk/MagicSoft/Mars/mbase/MInputStreamID.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MInputStreamID.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MInputStreamID.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MINPUTSTREAMID_H
-#define MINPUTSTREAMID_H
+#ifndef MARS_MInputStreamID
+#define MARS_MInputStreamID
 
 ///////////////////////////////////////////////////////////////////////
@@ -10,5 +10,5 @@
 ///////////////////////////////////////////////////////////////////////
 
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MLog.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MLog.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MLog.h	(revision 1014)
@@ -1,8 +1,5 @@
-#ifndef MLOG_H
-#define MLOG_H
+#ifndef MARS_MLog
+#define MARS_MLog
 
-//#ifndef MAGIC_H
-//#include "MAGIC.h"
-//#endif
 #ifndef ROOT_TObject
 #include <TObject.h>
Index: trunk/MagicSoft/Mars/mbase/MLogManip.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MLogManip.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MLogManip.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MLOGMANIP_H
-#define MLOGMANIP_H
+#ifndef MARS_MLogManip
+#define MARS_MLogManip
 
 #include <iomanip.h>
Index: trunk/MagicSoft/Mars/mbase/MParContainer.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MParContainer.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MParContainer.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MPARCONTAINER_H
-#define MPARCONTAINER_H
+#ifndef MARS_MParContainer
+#define MARS_MParContainer
 
 //////////////////////////////////////////////////////////////////////////
@@ -9,5 +9,5 @@
 //                                                                      //
 //////////////////////////////////////////////////////////////////////////
-#ifndef MAGIC_H
+#ifndef MARS_MAGIC
 #include "MAGIC.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MParList.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MParList.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MParList.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MPARLIST_H
-#define MPARLIST_H
+#ifndef MARS_MParList
+#define MARS_MParList
 
 /////////////////////////////////////////////////////////////////////////////
@@ -10,12 +10,8 @@
 /////////////////////////////////////////////////////////////////////////////
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-
 #ifndef ROOT_TObjArray
 #include <TObjArray.h>
 #endif
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MPrint.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MPrint.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MPrint.h	(revision 1014)
@@ -1,10 +1,6 @@
-#ifndef MPRINT_H
-#define MPRINT_H
+#ifndef MARS_MPrint
+#define MARS_MPrint
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-
-#ifndef MTASK_H
+#ifndef MARS_MTask
 #include "MTask.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MReadTree.cc
===================================================================
--- trunk/MagicSoft/Mars/mbase/MReadTree.cc	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MReadTree.cc	(revision 1014)
@@ -43,4 +43,5 @@
 //                                                                         //
 // FIXME: An automatic enabeling scheme would be nice.                     //
+//        Can we use TBranch::SetAutoDelete?                               //
 //                                                                         //
 // Later we'll use TChain::SetNotify to notify MReadTree if the TChain     //
Index: trunk/MagicSoft/Mars/mbase/MReadTree.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MReadTree.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MReadTree.h	(revision 1014)
@@ -1,6 +1,6 @@
-#ifndef MREADTREE_H
-#define MREADTREE_H
+#ifndef MARS_MReadTree
+#define MARS_MReadTree
 
-#ifndef MTASK_H
+#ifndef MARS_MTask
 #include "MTask.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MTask.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MTask.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MTask.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MTASK_H
-#define MTASK_H
+#ifndef MARS_MTask
+#define MARS_MTask
 
 /////////////////////////////////////////////////////////////////////////////
@@ -10,5 +10,5 @@
 /////////////////////////////////////////////////////////////////////////////
 
-#ifndef MINPUTSTREAMID_H
+#ifndef MARS_MInputStreamID
 #include "MInputStreamID.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MTaskList.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MTaskList.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MTaskList.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MTASKLIST_H
-#define MTASKLIST_H
+#ifndef MARS_MTaskList
+#define MARS_MTaskList
 
 ///////////////////////////////////////////////////////////////////////
@@ -10,5 +10,5 @@
 ///////////////////////////////////////////////////////////////////////
 
-#ifndef MTASK_H
+#ifndef MARS_MTask
 #include "MTask.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MTime.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MTime.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MTime.h	(revision 1014)
@@ -1,4 +1,4 @@
-#ifndef MTIME_H
-#define MTIME_H
+#ifndef MARS_MTime
+#define MARS_MTime
 
 /////////////////////////////////////////////////////////////////////////////
@@ -10,5 +10,5 @@
 /////////////////////////////////////////////////////////////////////////////
 
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MWriteAsciiFile.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MWriteAsciiFile.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MWriteAsciiFile.h	(revision 1014)
@@ -1,10 +1,10 @@
-#ifndef MWRITEASCIIFILE_H
-#define MWRITEASCIIFILE_H
+#ifndef MARS_MWriteAsciiFile
+#define MARS_MWriteAsciiFile
 
-#ifndef MWRITEFILE_H
+#ifndef MARS_MWriteFile
 #include "MWriteFile.h"
 #endif
 
-class MWriteAsciiFile : public MWriteFile //MTask
+class MWriteAsciiFile : public MWriteFile
 {
 private:
@@ -29,5 +29,5 @@
     ~MWriteAsciiFile();
 
-    ClassDef(MWriteAsciiFile, 0)	// Class to write one container to an ascii file
+    ClassDef(MWriteAsciiFile, 0) // Class to write one container to an ascii file
 };
 
Index: trunk/MagicSoft/Mars/mbase/MWriteFile.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MWriteFile.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MWriteFile.h	(revision 1014)
@@ -1,6 +1,6 @@
-#ifndef MWRITEFILE_H
-#define MWRITEFILE_H
+#ifndef MARS_MWriteFile
+#define MARS_MWriteFile
 
-#ifndef MTASK_H
+#ifndef MARS_MTask
 #include "MTask.h"
 #endif
Index: trunk/MagicSoft/Mars/mbase/MWriteRootFile.h
===================================================================
--- trunk/MagicSoft/Mars/mbase/MWriteRootFile.h	(revision 1009)
+++ trunk/MagicSoft/Mars/mbase/MWriteRootFile.h	(revision 1014)
@@ -1,6 +1,6 @@
-#ifndef MWRITEROOTFILE_H
-#define MWRITEROOTFILE_H
+#ifndef MARS_MWriteRootFile
+#define MARS_MWriteRootFile
 
-#ifndef MWRITEFILE_H
+#ifndef MARS_MWriteFile
 #include "MWriteFile.h"
 #endif