Index: trunk/MagicSoft/Mars/mhist/HistLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 1015)
@@ -5,15 +5,15 @@
 #pragma link off all functions;
 
-#pragma link C++ class MFillH;
+#pragma link C++ class MFillH+;
 
-#pragma link C++ class MH;
-#pragma link C++ class MHFadcCam;
-#pragma link C++ class MHFadcPix;
-#pragma link C++ class MHHillas;
-#pragma link C++ class MHStarMap;
-#pragma link C++ class MHMcEnergy;
-#pragma link C++ class MHMcCollectionArea;
+#pragma link C++ class MH+;
+#pragma link C++ class MHFadcCam+;
+#pragma link C++ class MHFadcPix+;
+#pragma link C++ class MHHillas+;
+#pragma link C++ class MHStarMap+;
+#pragma link C++ class MHMcEnergy+;
+#pragma link C++ class MHMcCollectionArea+;
 
-#pragma link C++ class MHMcRate;
+#pragma link C++ class MHMcRate+;
 
 #endif
Index: trunk/MagicSoft/Mars/mhist/MFillH.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MFillH.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MFillH.h	(revision 1015)
@@ -1,10 +1,6 @@
-#ifndef MFILLH_H
-#define MFILLH_H
+#ifndef MARS_MFillH
+#define MARS_MFillH
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-
-#ifndef MTASK_H
+#ifndef MARS_MTask
 #include "MTask.h"
 #endif
Index: trunk/MagicSoft/Mars/mhist/MH.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MH.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MH.h	(revision 1015)
@@ -1,10 +1,6 @@
-#ifndef MH_H
-#define MH_H
+#ifndef MARS_MH
+#define MARS_MH
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mhist/MHFadcCam.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFadcCam.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MHFadcCam.h	(revision 1015)
@@ -1,8 +1,4 @@
-#ifndef MHFADCCAM_H
-#define MHFADCCAM_H
-
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
+#ifndef MARS_MHFadcCam
+#define MARS_MHFadcCam
 
 #ifndef ROOT_TObjArray
@@ -10,8 +6,8 @@
 #endif
 
-#ifndef MH_H
+#ifndef MARS_MH
 #include "MH.h"
 #endif
-#ifndef MHFADCPIX_H
+#ifndef MARS_MHFadcPix
 #include "MHFadcPix.h"
 #endif
Index: trunk/MagicSoft/Mars/mhist/MHFadcPix.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFadcPix.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MHFadcPix.h	(revision 1015)
@@ -1,16 +1,12 @@
-#ifndef MHFADCPIX_H
-#define MHFADCPIX_H
+#ifndef MARS_MHFadcPix
+#define MARS_MHFadcPix
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
+#ifndef MARS_MParContainer
+#include "MParContainer.h"
 #endif
-
-//#ifndef ROOT_TH1
-//#include <TH1.h>
-//#endif
 
 class TH1F;
 
-class MHFadcPix : public TObject
+class MHFadcPix : public MParContainer
 {
 private:
Index: trunk/MagicSoft/Mars/mhist/MHHillas.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHHillas.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MHHillas.h	(revision 1015)
@@ -1,10 +1,6 @@
-#ifndef MHHILLAS_H
-#define MHHILLAS_H
+#ifndef MARS_MHHillas
+#define MARS_MHHillas
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-
-#ifndef MH_H
+#ifndef MARS_MH
 #include "MH.h"
 #endif
Index: trunk/MagicSoft/Mars/mhist/MHMcCollectionArea.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHMcCollectionArea.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MHMcCollectionArea.h	(revision 1015)
@@ -1,9 +1,6 @@
-#ifndef MHMCCOLLECTIONAREA_H
-#define MHMCCOLLECTIONAREA_H
+#ifndef MARS_MHMcCollectionArea
+#define MARS_MHMcCollectionArea
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mhist/MHMcEnergy.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHMcEnergy.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MHMcEnergy.h	(revision 1015)
@@ -1,9 +1,6 @@
-#ifndef MHMCENERGY_H
-#define MHMCENERGY_H
+#ifndef MARS_MHMcEnergy
+#define MARS_MHMcEnergy
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mhist/MHMcRate.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHMcRate.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MHMcRate.h	(revision 1015)
@@ -1,9 +1,6 @@
-#ifndef MHMCRATE_H
-#define MHMCRATE_H
+#ifndef MARS_MHMcRate
+#define MARS_MHMcRate
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-#ifndef MPARCONTAINER_H
+#ifndef MARS_MParContainer
 #include "MParContainer.h"
 #endif
Index: trunk/MagicSoft/Mars/mhist/MHStarMap.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHStarMap.h	(revision 1004)
+++ trunk/MagicSoft/Mars/mhist/MHStarMap.h	(revision 1015)
@@ -1,10 +1,6 @@
-#ifndef MHSTARMAP_H
-#define MHSTARMAP_H
+#ifndef MARS_MHStarMap
+#define MARS_MHStarMap
 
-#ifndef MAGIC_H
-#include "MAGIC.h"
-#endif
-
-#ifndef MH_H
+#ifndef MARS_MH
 #include "MH.h"
 #endif